.386

.model flat, stdcall 
option casemap :none 

	include \MASM32\INCLUDE\windows.inc
	include \MASM32\INCLUDE\user32.inc
	include \MASM32\INCLUDE\kernel32.inc
	include \MASM32\INCLUDE\setupapi.inc

	includelib \MASM32\LIB\user32.lib
	includelib \MASM32\LIB\kernel32.lib
	includelib \masm32\LIB\setupapi.lib

_GUIDX STRUCT
  Data1			DWORD ?
  Data2			WORD ?
  Data3			WORD ?
  Data4			byte 8 dup(?)           
_GUIDX ends

_SP_DEVINFO_DATA struct
  cbSize		DWORD ?
  ClassGuid		_GUID <>
  DevInst		DWORD ?
  Reserved		DWORD ?
_SP_DEVINFO_DATA ends

_SP_DEVICE_INTERFACE_DATA STRUCT
  cbSize		DWORD ?
  InterfaceClassGuid	_GUID <>
  Flags			DWORD ?
  Reserved		DWORD ?
_SP_DEVICE_INTERFACE_DATA ends

_SP_DEVICE_INTERFACE_DETAIL_DATA STRUCT
  cbSize		DWORD ?
  DevicePath		db 1 dup(?)	;[ANYSIZE_ARRAY]
_SP_DEVICE_INTERFACE_DETAIL_DATA ends

_MOUNTMGR_MOUNT_POINT struc
  SymbolicLinkNameOffset	DWORD ?
  SymbolicLinkNameLength	WORD ?
  UniqueIdOffset		DWORD ?
  UniqueIdLength		WORD ?
  DeviceNameOffset		DWORD ?
  DeviceNameLength		WORD ?
_MOUNTMGR_MOUNT_POINT ends

_MOUNTMGR_MOUNT_POINTS struc
  Size1				DWORD ?
  NumberOfMountPoints		DWORD ?
  MountPoints			_MOUNTMGR_MOUNT_POINT <>
_MOUNTMGR_MOUNT_POINTS ends

_MOUNTDEV_NAME struc
  NameLength			WORD ?
  Name1				db 1024 dup(?)
_MOUNTDEV_NAME ends

.const
DIGCF_PRESENT		equ 00000002h
DIGCF_ALLCLASSES	equ 00000004h
DIGCF_PROFILE		equ 00000008h
DIGCF_DEVICEINTERFACE	equ 00000010h
SPDRP_HARDWAREID	equ 00000001h
SPDRP_COMPATIBLEIDS	equ 00000002h
SPDRP_CLASSGUID		equ 00000008h
USBGUID			_GUIDX <0A5DCBF10h, 06530h, 011D2h, <090h, 01Fh, 000h, 0C0h, 04Fh, 0B9h, 051h, 0EDh>>
DISKGUID		_GUIDX <053f56307h, 0b6bfh, 011d0h, <94h , 0f2h, 000h, 0a0h, 0c9h, 01eh, 0fbh, 08bh>>
VOLUMEGUID		_GUIDX <053f5630dh, 0b6bfh, 011d0h, <94h , 0f2h, 000h, 0a0h, 0c9h, 01eh, 0fbh, 08bh>>
IOCTL_MOUNTMGR_QUERY_POINTS		equ 006D0008h
IOCTL_MOUNTDEV_QUERY_DEVICE_NAME	equ 004D0008h

.data
form			db "ERROR: %u", 0
form1			db "ERROR1: %u", 0
form2			db "ERROR2: %u", 0
form3			db "ERROR3: %u", 0
perenos			db 13,10,0

.data?
buffer			db 512 dup(?)
string			db 1024 dup(?)
Devinfo			_SP_DEVINFO_DATA <>
Interface		_SP_DEVICE_INTERFACE_DATA <>
InterfaceDetailed	_SP_DEVICE_INTERFACE_DETAIL_DATA <>
			db 512 dup(?)	;
MountmgrMountPoint	_MOUNTMGR_MOUNT_POINT <>
MountmgrMountPoints	_MOUNTMGR_MOUNT_POINTS <>
MountDevName		_MOUNTDEV_NAME <>
cw			dd ?

.code
start:
invoke SetupDiGetClassDevs,addr DISKGUID,0,0,DIGCF_PRESENT OR DIGCF_DEVICEINTERFACE
.if eax !=INVALID_HANDLE_VALUE
	mov ebx, eax
	mov Interface.cbSize, sizeof Interface
	xor edi, edi
NEXT:
	invoke SetupDiEnumDeviceInterfaces, ebx, NULL, addr DISKGUID, edi, addr Interface
	.if eax == TRUE
		invoke SetupDiGetDeviceInterfaceDetail, ebx, addr Interface, NULL, NULL, addr cw, NULL
		mov InterfaceDetailed.cbSize, sizeof _SP_DEVICE_INTERFACE_DETAIL_DATA
		invoke SetupDiGetDeviceInterfaceDetail, ebx, addr Interface, addr InterfaceDetailed, cw, addr cw, NULL
		.if eax == TRUE
			lea eax, InterfaceDetailed.DevicePath
			;.if dword ptr[eax]==5c3f5c5ch && dword ptr[eax+4]==73627375h && dword ptr[eax+8]==23726f74h; \\?\USBSTOR#
				invoke MessageBox,0,addr InterfaceDetailed.DevicePath,0,MB_ICONASTERISK
				invoke CreateFile,addr InterfaceDetailed.DevicePath,GENERIC_READ OR GENERIC_WRITE,\
				FILE_SHARE_READ OR FILE_SHARE_WRITE,0, OPEN_EXISTING,0,0
				.if eax!=INVALID_HANDLE_VALUE
					mov esi, eax
					invoke DeviceIoControl, esi, IOCTL_MOUNTDEV_QUERY_DEVICE_NAME, \
					0, 0,\
					addr MountDevName,sizeof MountDevName, addr cw, 0
					.if eax!=0
						invoke MessageBoxW,0,addr [MountDevName.Name1],0,MB_ICONASTERISK
					.else
						invoke GetLastError
						invoke wsprintf,ADDR buffer,addr form2, eax
						invoke MessageBox,0,addr buffer,0,MB_ICONASTERISK
					.endif
					invoke CloseHandle, esi
				.else
					invoke GetLastError
					invoke wsprintf,ADDR buffer,ADDR form1,eax
					invoke MessageBox,0,addr buffer,0,MB_ICONASTERISK
				.endif
			;.endif
		.endif
		add edi, 1
		jmp NEXT
	.endif
	invoke SetupDiDestroyDeviceInfoList, ebx
.else
	invoke GetLastError
	invoke wsprintf,ADDR buffer,ADDR form,eax
	invoke MessageBox,0,ADDR buffer,0,MB_ICONASTERISK
.endif
invoke ExitProcess,0
end start